=== debian/changelog ===
vcmi (0.99+dfsg+git20220621.54fab9f0-3build1) kinetic; urgency=medium

  * No-change rebuild against libavcodec59

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 19 Jul 2022 13:09:52 +0000

vcmi (0.99+dfsg+git20220621.54fab9f0-3) unstable; urgency=medium

  * debian/salsa-ci.yml: build with noautodbgsym to avoid hitting the salsaci
    maximum artifact size limit
  * bump dh compat to 13
  * debian/copyright: remove dropped cmake modules
  * debian/copyright: add section for launcher/eu.vcmi.VCMI.metainfo.xml
  * debian/watch: bump version to 4
  * debian/rules: remove --ddeb-migration as dbgsym migration is complete
  * add Forwarded: not-needed to patches
  * debian/control: bump Standards-Version to 4.6.0 (no changes)
  * debian/control: add Rules-Requires-Root: no

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Sun, 17 Jul 2022 22:49:39 +0200

vcmi (0.99+dfsg+git20220621.54fab9f0-2) unstable; urgency=medium

  * move from experimental to unstable
  * the latest upstream git commit also fixes vcmibuilder --gog (closes:
    #836527)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Mon, 04 Jul 2022 15:12:18 +0200

vcmi (0.99+dfsg+git20220621.54fab9f0-1) experimental; urgency=medium

  * Still no release, so we package the latest git commit.
     - link with tbb (closes: #991460)
     - compatibility with ffmpeg 5.0.1 (closes: #1013419)
  * refresh patches
  * fix my name
  * run wrap-and-sort -astb
  * debian/control: add B-D on libtbb-dev, libluajit-5.1-dev, googletest, libgmock-dev
  * debian/rules: disable tests to prevent compilation errors

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Fri, 24 Jun 2022 12:06:26 +0200
