=== debian/watch ===
version=4
opts=compression=xz,repacksuffix=+dfsg,dversionmangle=s/\+dfsg$// \
  https://github.com/vcmi/vcmi/releases (?:.*/)(\d[\d\.]*)\.tar\.gz
